#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))
#define HISTOGRAM_SIZE                  20
#define POCET	10000


double lichobeznik()
{
  double                ppst[] = { 0.0, 0.25, 0.75, 1.0};
  double                interval[] = { 0.0, 1.0, 2.0, 3.0};
  double                y1, y2;
  int                   i;

  y1 = (double)rand() / RAND_MAX;
  for ( i = 0; y1 > ppst[i]; i++);

  switch (i)
  {
    case 0:
      return 0;
    case 1:	
      y1 = (double)rand() / RAND_MAX;
      y2 = (double)rand() / RAND_MAX;
      return (interval[0] + max(y1, y2));
    case 2:
      y1 = (double)rand() / RAND_MAX;
      return (interval[1] + y1);
    case 3:
      y1 = (double)rand() / RAND_MAX;
      y2 = (double)rand() / RAND_MAX;
      return (interval[2] + min(y1, y2));
  } // switch

  return -1;
}

int main()
{
  double                x;  
  int                   historie[HISTOGRAM_SIZE + 2] = { 0 };
  double                Delta = (2.5 - 1.5) / HISTOGRAM_SIZE; // deleni intervalu
  double                border[HISTOGRAM_SIZE + 1] = { 0 };
  int i,j;
  double  suma = 0;
  
  border[0] = 1.5;
  for ( i = 1; i <= HISTOGRAM_SIZE; i++)
    border[i] = border[i - 1] + Delta;
  for ( i = 0; i < POCET; i++) 
  {
    x = lichobeznik();
    for (j = 0; x >= border[j]; j++);
    historie[j]++;
  } 


  for ( i = 1; i <= HISTOGRAM_SIZE; i++)
    suma += historie[i];
  
   printf("Pravdepodobnost vyskytu v intervalu <1.5, 2.5> je %2.3lf%%\n", 
     100*(double)suma / POCET);

	getchar();
  return 0;
}