/*
  KIV/VSP - Vykonnost a spolehlivost cislicovych systemu
 
  1.cpp
	Uloha cislo 2
  Vytvote genertor lichobnkovho rozdlen

	f(x) = 0 pro x<0 
	f(x) lin. roste pro 1>x>0 
	f(x) je konst pro 2>x>1 
	f(x) lin. kles pro 3>x>2 
	f(x) = 0 pro x>3 
	jako funkci v C. Pouijte vyluovac metodu.


	V hlavnm programu testujte genertor vytvoenm histogramu.	

	Hezina Jan 13.10.2002
 */


#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))
#define HISTOGRAM_SIZE                  10
#define POCET	1000000
/**
 * Generuje nahodne cislo, ktere ma lichobeznikove rozdeleni. Nahodnde cislo
 * se generuje vylucovaci metodou
 *
 * @return    vrati nahodne cislo s lichobeznikovym rozdelenim
 */
double rand_lich()
{
  double                p[] = { 0.0, 0.25, 0.75, 1.0};
  double                b[] = { 0.0, 1.0, 2.0, 3.0};
  double                y, y2;
  int                   i;

  y = (double)rand() / RAND_MAX;
  for (i = 0; y > p[i]; i++);

  switch (i)
  {
    case 0:
      return 0;
    case 1:	
      y = (double)rand() / RAND_MAX;
      y2 = (double)rand() / RAND_MAX;
      return (b[0] + max(y, y2));
    case 2:
      y = (double)rand() / RAND_MAX;
      return (b[1] + y);
    case 3:
      y = (double)rand() / RAND_MAX;
      y2 = (double)rand()/  RAND_MAX;
      return (b[ 2]+ min(y, y2));
  } // switch

  return -1;
}

int main()
{
  double                x;  
  int                   historie[HISTOGRAM_SIZE + 2] = { 0 };
  double                Delta = (2.5 - 1.5) / HISTOGRAM_SIZE; // deleni intervalu
  double                border[HISTOGRAM_SIZE + 1] = { 0 };
  int i;
  
  border[0] = 1.5;
  for ( i = 1; i <= HISTOGRAM_SIZE; i++)
    border[i] = border[i - 1] + Delta;
  for ( i = 0; i < POCET; i++){
    x = rand_lich();
    //printf("%lf\t",x);
	int                 idx;
    for (idx = 0; x >= border[idx]; idx++);
    historie[idx]++;
  } // for

  double                suma = 0;
  for ( i = 1; i <= HISTOGRAM_SIZE; i++)
    suma += historie[i];
  
  for ( i = 1; i <= HISTOGRAM_SIZE; i++)
	  printf("%1.1lf\t%d\n",border[i],historie[i]);
 
  printf("Pravdepodobnost vyskytu v intervalu <1.5, 2.5> je %3.3lf%%\n", 
     100*(double)suma / POCET);

	getchar();
  return 0;
}